commit 7230ae73c96dc7d19f072627e1f9c48e008e03b8
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Sun Nov 21 21:08:04 2021

    fortran, debug: Fix up DW_AT_rank [PR103315]
    
    For DW_AT_rank we were emitting
            .uleb128 0x4    # DW_AT_rank
            .byte   0x97    # DW_OP_push_object_address
            .byte   0x23    # DW_OP_plus_uconst
            .uleb128 0x1c
            .byte   0x6     # DW_OP_deref
    on 64-bit and
            .uleb128 0x4    # DW_AT_rank
            .byte   0x97    # DW_OP_push_object_address
            .byte   0x23    # DW_OP_plus_uconst
            .uleb128 0x10
            .byte   0x6     # DW_OP_deref
    on 32-bit.  I think this is wrong, as dtype.rank field in the descriptor
    has unsigned char type, not pointer type nor pointer sized integral.
    E.g. if we have a
        REAL :: a(..)
    dummy argument, which is passed as a reference to the function descriptor,
    we want to evaluate a->dtype.rank.  The above DWARF expressions perform
    *(uintptr_t *)(a + 0x1c)
    and
    *(uintptr_t *)(a + 0x10)
    respectively.  The following patch changes those to:
            .uleb128 0x5    # DW_AT_rank
            .byte   0x97    # DW_OP_push_object_address
            .byte   0x23    # DW_OP_plus_uconst
            .uleb128 0x1c
            .byte   0x94    # DW_OP_deref_size
            .byte   0x1
    and
            .uleb128 0x5    # DW_AT_rank
            .byte   0x97    # DW_OP_push_object_address
            .byte   0x23    # DW_OP_plus_uconst
            .uleb128 0x10
            .byte   0x94    # DW_OP_deref_size
            .byte   0x1
    which perform
    *(unsigned char *)(a + 0x1c)
    and
    *(unsigned char *)(a + 0x10)
    respectively.
    
    2021-11-21  Jakub Jelinek  <jakub@redhat.com>
    
            PR debug/103315
            * trans-types.c (gfc_get_array_descr_info): Use DW_OP_deref_size 1
            instead of DW_OP_deref for DW_AT_rank.
    
    (cherry picked from commit da17c304e22ba256eba0b03710aa329115163b08)

diff --git a/gcc/fortran/trans-types.c b/gcc/fortran/trans-types.c
index 604e816dc27..d6520eee5c0 100644
--- a/gcc/fortran/trans-types.c
+++ b/gcc/fortran/trans-types.c
@@ -3435,8 +3435,8 @@ gfc_get_array_descr_info (const_tree type, struct array_descr_info *info)
       if (!integer_zerop (dtype_off))
 	t = fold_build_pointer_plus (t, rank_off);
 
-      t = build1 (NOP_EXPR, build_pointer_type (gfc_array_index_type), t);
-      t = build1 (INDIRECT_REF, gfc_array_index_type, t);
+      t = build1 (NOP_EXPR, build_pointer_type (TREE_TYPE (field)), t);
+      t = build1 (INDIRECT_REF, TREE_TYPE (field), t);
       info->rank = t;
       t = build0 (PLACEHOLDER_EXPR, TREE_TYPE (dim_off));
       t = size_binop (MULT_EXPR, t, dim_size);

